TSSBASE = tss
TYPE = 10001011b shl 24
TT = TYPE or TSSBASE
EFLAGS = 0001b shl 4
EFL = EFLAGS or 0

setgdt:
cli
lgdt PWORD[_gp]
mov ax,40
ltr ax
mov ax,16
mov ds,ax
mov es,ax
mov fs,ax
mov gs,ax
mov esp,stackend
jmp 8:kernel
sti
ret;end of function(not finished)


_gp:
dw gdtend-gdtstart-1
dd gdtstart


gdtstart:
dd 0,0;this is the null entry

;next code 0
dw 0xFFFF;first part of limit
db 0,0,0;first part of base
db 10011010b;this is the access byte
db 11001111b;this is the flags and the rest of the limit
db 0;this is the rest of the base

;next data 0
dw 0xFFFF
db 0,0,0
db 10010010b;access byte
db 11001111b;flags and limit
db 0;

;code 3
dw 0xFFFF;first part of limit
db 0,0,0;first part of base
db 11111010b;this is the access byte
db 11001111b;this is the flags and the rest of the limit
db 0;this is the rest of the base

;next data 3
dw 0xFFFF
db 0,0,0
db 11110010b;access byte
db 11001111b;flags and limit
db 0;
;tss
db 0;this part of base is unused
db EFL
dd TT
dw 0x67

gdtend:

tss:
times 0x67 dd 0;alocate space for a tss
